﻿Imports Telerik.WinControls.UI
Imports Telerik.WinControls.Primitives

Public Class Form1
    Sub New()

        InitializeComponent()

        AddHandler Me.RadGridView1.CellValidating, AddressOf RadGridView1_CellValidating
        Me.RadGridView1.DataSource = Me.GetData()
    End Sub

    Private Function GetData() As DataTable
        Dim dt As New DataTable()
        dt.Columns.Add("Id", GetType(Integer))
        dt.Columns.Add("Name", GetType(String))
        dt.Columns.Add("Date", GetType(DateTime))
        dt.Columns.Add("Bool", GetType(Boolean))
        dt.Columns.Add("Description", GetType(String))

        For i As Integer = 0 To 999
            dt.Rows.Add(i, "Name " & i, DateTime.Now.AddDays(i), i Mod 2 = 0, "Description " & i)
        Next

        Return dt
    End Function

    Private Sub RadGridView1_CellValidating(sender As Object, e As Telerik.WinControls.UI.CellValidatingEventArgs)
        Dim dataRow As GridViewDataRowInfo = TryCast(e.Row, GridViewDataRowInfo)
        If dataRow IsNot Nothing Then
            dataRow.ErrorText = "This is error text"
        ElseIf TypeOf e.Row Is GridViewNewRowInfo Then
            e.Row.Tag = "This is error text"
        End If
    End Sub

    Private Sub RadGridView1_CreateCell(sender As Object, e As Telerik.WinControls.UI.GridViewCreateCellEventArgs) Handles RadGridView1.CreateCell
        If e.CellType = GetType(GridRowHeaderCellElement) Then
            e.CellType = GetType(CustomGridRowHeaderCellElement)
        End If
    End Sub
End Class

Public Class CustomGridRowHeaderCellElement
    Inherits GridRowHeaderCellElement

    Public Sub New(column As GridViewColumn, row As GridRowElement)
        MyBase.New(column, row)
    End Sub

    Public Overrides Sub UpdateInfo()
        MyBase.UpdateInfo()

        If TypeOf Me.RowInfo Is GridViewNewRowInfo Then
            If Me.RowInfo.Tag Is Nothing Then
                Me.ErrorImage.Image = Nothing
                Me.ToolTipText = [String].Empty
            Else
                Me.ToolTipText = Convert.ToString(Me.RowInfo.Tag)
                Me.ErrorImage.Image = Me.TableElement.ErrorRowHeaderImage
            End If
        End If
    End Sub

    Private ReadOnly Property ErrorImage() As ImagePrimitive

        Get
            If Me.Children.Count = 0 Then
                Return Nothing
            End If

            Return TryCast(Me.Children(0), ImagePrimitive)
        End Get
    End Property
End Class
